*** a/src/backend/replication/walsender.c
--- b/src/backend/replication/walsender.c
***************
*** 474,482 **** InitWalSnd(void)
  		}
  	}
  	if (MyWalSnd == NULL)
! 		ereport(FATAL,
! 				(errcode(ERRCODE_TOO_MANY_CONNECTIONS),
! 				 errmsg("sorry, too many standbys already")));
  
  	/* Arrange to clean up at walsender exit */
  	on_shmem_exit(WalSndKill, 0);
--- 474,489 ----
  		}
  	}
  	if (MyWalSnd == NULL)
! 	{
! 		if (MaxWalSenders == 0)
! 			ereport(FATAL,
! 					(errcode(ERRCODE_TOO_MANY_CONNECTIONS),
! 					 errmsg("could not accept connection from the standby because max_wal_senders is 0")));
! 		else
! 			ereport(FATAL,
! 					(errcode(ERRCODE_TOO_MANY_CONNECTIONS),
! 					 errmsg("sorry, too many standbys already")));
! 	}
  
  	/* Arrange to clean up at walsender exit */
  	on_shmem_exit(WalSndKill, 0);
